# Bootstrap step

A baseline step performs an experiment (a baseline experiment) and marks it as the initial experiment of a study. The purpose of the step is to build a reference configuration that Akamas can use to measure the effectiveness of an optimization conducted towards a system.

When a bootstrap step imports an experiment from another study, the step copies not only the experiment but also its trials and the system metrics generated during its execution.

The bootstrap step has the following structure:

| Field          | Type             | Value restrictions                                    | Is required | Default value | Description                                                                                                                                                                                                                    |
| -------------- | ---------------- | ----------------------------------------------------- | ----------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `type`         | string           | `bootstrap`                                           | yes         |               | The type of the step, in this case, `bootstrap`                                                                                                                                                                                |
| `name`         | string           |                                                       | yes         |               | The name of the step                                                                                                                                                                                                           |
| `runOnFailure` | boolean          | <p><code>true</code><br><code>false</code></p>        | no          | `false`       | <p>The execution policy of the step:</p><ul><li><code>false</code> prevents the step from running in case the previous step failed</li><li><code>true</code> allows the step to run even if the previous step failed</li></ul> |
| `from`         | array of objects | Each object should have the structure described below | yes         |               | <p>The experiments to import in the current study</p><p>In case this is not set, this step imports every experiment of a study</p>                                                                                             |

where the `from` field should have the following structure:

{% code lineNumbers="true" %}

```yaml
study: "study_bootstrap_1" 2experiments: [1,2,3]
```

{% endcode %}

with:

* `study` contains the name or id of the study from which to import experiments
* `experiments` contains the numbers of the experiments from which to import

### Examples

The following is an example of a bootstrap step that imports four experiments from two studies:

{% code lineNumbers="true" %}

```yaml
name: "my_bootstrap" # name of the step
type: "bootstrap" # type of the step (bootstrap)
from:
  - study: "study_bootstap_1" # name or id of the study from which to import
    experiments: [1, 2, 4] # the numbers of the experiments to import
  - study: "study_bootstrap_2"
    experiments: [1]
```

{% endcode %}

You can also import all the experiments of a study by omitting the `experiments` field:

{% code lineNumbers="true" %}

```yaml
name: "my_bootstrap" # name of the step
type: "bootstrap" # type of the step (bootstrap)
from:
  - study: "study_bootstrap_1" # name or id of the study from which to import
```

{% endcode %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.akamas.io/akamas-docs/3.1.2/akamas-reference/construct-templates/study-template/steps/bootstrap-step.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
